--------------------------------------------------------------------------------
-- Company: <Name>
--
-- File: ZL30265_CTRL.vhd
-- File history:
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--
-- Description: 
--
-- <Description here>
--
-- Targeted device: <Family::PolarFire> <Die::MPF300T_ES> <Package::FCG1152>
-- Author: <Name>
--
--------------------------------------------------------------------------------

library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity ZL30265_CTRL is
generic (
    max : integer range 0 to 65535 := 65535
);
port (
    nReset       : in    std_logic;
    clk          : in    std_logic;
    IF0          : in    std_logic;
    IF1          : in    std_logic;
    SCLK         : in    std_logic;
    MOSI         : in    std_logic;
    CSn          : in    std_logic;
    ZL30265_MISO : inout std_logic;
    ZL30265_SCLK : out   std_logic;
    ZL30265_MOSI : out   std_logic;
    ZL30265_RSTn : out   std_logic;
    ZL30265_CSn  : out   std_logic;
    ZL30265_AC0  : out   std_logic;
    ZL30265_AC1  : out   std_logic;
    ZL30265_AC2  : out   std_logic;
    ZL30265_TEST : out   std_logic;
    MISO         : out   std_logic
);
end ZL30265_CTRL;
architecture architecture_ZL30265_CTRL of ZL30265_CTRL is

	signal delay_counter : std_logic_vector(15 downto 0);

begin

    ZL30265_AC0  <= '0';
    ZL30265_AC1  <= '0';
    ZL30265_AC2  <= '0';
    ZL30265_TEST <= '0';

    ZL30265_SCLK <= SCLK;
    ZL30265_MOSI <= MOSI;


    delay_counterP : process(clk, nReset)
    begin
        if(nReset = '0') then
            delay_counter <= (others => '0');
        elsif(clk'event and clk = '1') then
            if(delay_counter < max) then
                delay_counter <= delay_counter + 1;
            end if;
        end if;
    end process delay_counterP;

    ZL30265_RSTn <= '0' when (delay_counter < max) else '1';
    ZL30265_CSn  <= IF0 when (delay_counter < max) else CSn;
    ZL30265_MISO <= IF1 when (delay_counter < max) else 'Z';
    MISO         <= ZL30265_MISO;

end architecture_ZL30265_CTRL;
